--- markdown.php.old	2007-11-27 23:50:56.000000000 +0100
+++ markdown.php	2008-02-17 10:45:09.000000000 +0100
@@ -1471,7 +1471,8 @@
 class MarkdownExtra_Parser extends Markdown_Parser {
 
 	# Prefix for footnote ids.
-	var $fn_id_prefix = "";
+	var $fn_id_prefix = '';
+	var $footnote_uid = 0;
 	
 	# Optional title attribute for footnote links and backlinks.
 	var $fn_link_title = MARKDOWN_FN_LINK_TITLE;
@@ -2432,17 +2433,18 @@
 				$attr2 = str_replace("%%", ++$num, $attr);
 				
 				# Add backlink to last paragraph; create new paragraph if needed.
-				$backlink = "<a href=\"#fnref:$note_id\"$attr2>&#8617;</a>";
+				$backlink = "<a href=\"#fnref:".$this->footnote_uid.":$note_id\"$attr2>&#8617;</a>";
 				if (preg_match('{</p>$}', $footnote)) {
 					$footnote = substr($footnote, 0, -4) . "&#160;$backlink</p>";
 				} else {
 					$footnote .= "\n\n<p>$backlink</p>";
 				}
 				
-				$text .= "<li id=\"fn:$note_id\">\n";
+				$text .= "<li id=\"fn:".$this->footnote_uid.":$note_id\">\n";
 				$text .= $footnote . "\n";
 				$text .= "</li>\n\n";
 			}
+			++$this->footnote_uid;
 			
 			$this->in_footnote = false;
 			
@@ -2478,8 +2480,8 @@
 			$attr = str_replace("%%", $num, $attr);
 			
 			return
-				"<sup id=\"fnref:$node_id\">".
-				"<a href=\"#fn:$node_id\"$attr>$num</a>".
+				"<sup id=\"fnref:".$this->footnote_uid.":$node_id\">".
+				"<a href=\"#fn:".$this->footnote_uid.":$node_id\"$attr>$num</a>".
 				"</sup>";
 		}
 		
